/***************************************************************************
 *   Copyright (C) 2005 by Peter Donis                                     *
 *   peterdonis@alum.mit.edu                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _KIDSERVERWIDGET_H_
#define _KIDSERVERWIDGET_H_

#include <qvalidator.h>
#include "kidserverwidgetbase.h"

class kidserverWidget : public kidserverWidgetBase
{
  Q_OBJECT
  public:
    kidserverWidget(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~kidserverWidget();
    /*$PUBLIC_FUNCTIONS$*/
    const char *URL_text();
    const char *protocol_arg();
    const char *port_arg();
    bool DNS_only();
    bool protocol_set();
    bool port_set();
    void lineEditURL_setText( const char *text );
    void kTextBrowserOutput_output( const char *newtext );
    void kTextBrowserOutput_clear();
    void proc_running();
    void proc_stopped();

  public slots:
    /*$PUBLIC_SLOTS$*/

  protected:
    /*$PROTECTED_FUNCTIONS$*/

  protected slots:
    /*$PROTECTED_SLOTS$*/
    void checkBoxDNSonly_toggled( bool );
    void checkBoxProtocol_toggled( bool );
    void checkBoxPort_toggled( bool );
    void comboBoxProtocol_activated( int );
    void lineEditURL_returnPressed();

  private:
    QIntValidator *portval;

    void setportnum();
    void enableproto();
    void enableportnum();
    void enablespecs();
};

#endif
